import { CancelEventArgs } from "igniteui-webcomponents-core/ES5/igc-cancel-event-args";
import { SpreadsheetHyperlinkExecutingEventArgs as SpreadsheetHyperlinkExecutingEventArgs_internal } from "./SpreadsheetHyperlinkExecutingEventArgs";
import { WorksheetHyperlink } from "igniteui-webcomponents-excel/ES5/WorksheetHyperlink";
/**
 * Event arguments for the hyperlinkExecuting event.
*/
export declare class SpreadsheetHyperlinkExecutingEventArgs extends CancelEventArgs {
    /**
                                 * @hidden
                                 */
    readonly i: SpreadsheetHyperlinkExecutingEventArgs_internal;
    constructor();
    /**
     * Returns the hyperlink to be executed.
    */
    readonly hyperlink: WorksheetHyperlink;
    /**
     * Returns or sets the working directory to use when the hyperlink is a file reference.
    */
    workingDirectory: string;
}
